﻿local FSwapper3 = LibStub("AceAddon-3.0"):GetAddon("FSwapper3");
local L = LibStub("AceLocale-3.0"):GetLocale("FSwapper3", true);

local ldb = LibStub:GetLibrary("LibDataBroker-1.1");
FSwapper3.MainBroker = ldb:NewDataObject("FSwapper3", {type = "data source", icon = "Interface\\Icons\\INV_Fishingpole_01", text = "", label = "FSwapper3", tocname = "FSwapper3"});
FSwapper3.SkillBroker = ldb:NewDataObject("FSwapper3Skill", {type = "data source", icon = "Interface\\Icons\\Trade_Fishing", text = "", label = FSwapper3.LFISHINGSKILL, tocname = "FSwapper3"});

local dotooltip = -1;

local MainBroker = FSwapper3.MainBroker;
local SkillBroker = FSwapper3.SkillBroker;

local menuitem = {};
local FSwapper3Menu = CreateFrame("Frame", "FSwapper3Menu")

SkillBroker.Skill, SkillBroker.Bonus, SkillBroker.SkillMax, SkillBroker.SkillIndex, SkillBroker.SkillStr = 0, 0, 0, -1, FSwapper3.FISHINGSKILL_NULL;

function FSwapper3:DoDBUpdate()
	local itemlink, itemsubtype, _;

	FSwapper3:UpdateSkill();

	if (not FSwapper3.db.char.Enable) then
		MainBroker.text = L["|cffff0000[Disabled]|r"];
		dotooltip = 0;
		return;
	end

	itemlink = GetInventoryItemLink("player", 16);
	if (itemlink) then
		_, _, _, _, _, _, itemsubtype = GetItemInfo(itemlink);
	end
	
	if (itemsubtype == FSwapper3.LFISHINGPOLES) then
		MainBroker.text = FSwapper3.ISFISHING;
		dotooltip = 2;
	elseif (FSwapper3.WasFishing) then
		MainBroker.text = FSwapper3.ISCOMBAT;
		dotooltip = 3;
	else
		MainBroker.text = L["|cff00ff00[Enabled]|r"];
		dotooltip = 1;
	end

	if ((FSwapper3.db.char.FSTooltip == 0) or (SkillBroker.SkillIndex == -1)) then
		SkillBroker.text = SkillBroker.SkillStr;
	elseif (FSwapper3.db.char.FSTooltip == 1) then
		if (SkillBroker.Bonus > 0) then
			SkillBroker.text = format(FSwapper3.FISHINGSKILL_BONUS_MAX, SkillBroker.Skill + SkillBroker.Bonus, SkillBroker.SkillMax);
		else
			SkillBroker.text = format(FSwapper3.FISHINGSKILL_SKILL_MAX, SkillBroker.Skill, SkillBroker.SkillMax);
		end
	else
		if (SkillBroker.Bonus > 0) then
			SkillBroker.text = format(FSwapper3.FISHINGSKILL_BONUS, SkillBroker.Skill + SkillBroker.Bonus);
		else
			SkillBroker.text = format(FSwapper3.FISHINGSKILL_SKILL, SkillBroker.Skill);
		end
	end
end

function MainBroker:OnTooltipShow()
	self:AddLine("FSwapper3");
	self:AddLine(" ");

	if (dotooltip == 0) then
		self:AddLine(L["|cffff0000[Disabled]|r"]);
		self:AddLine(L["Click to |cff00ff00enable|r FSwapper3."]);
        self:AddLine(L["Right-Click for options."]);
	elseif (dotooltip == 1) then
		self:AddLine(L["|cff00ff00[Enabled]|r"]);
		self:AddLine(L["Click to go |cff00fffffishing|r."]);
		self:AddLine(L["Right-Click for options."]);
	elseif (dotooltip == 2) then
		self:AddLine(L["|cff00ffffA Fishing Pole is equipt.|r"]);
		self:AddLine(L["Click to equip your weapons."]);
		self:AddLine(L["Right-Click for options."]);
	elseif (dotooltip == 3) then
		self:AddLine(L["|cffff0000Combat interrupted fishing!|r"]);
		self:AddLine(L["Click to clear |cffff0000combat|r status."]);
		self:AddLine(L["Right-Click for options."]);
	end

	self:AddLine(" ");

	self:AddLine(format("%s: %s", FSwapper3.LFISHINGSKILL, SkillBroker.SkillStr));

	self:AddLine(" ");

	if ((FSwapper3.db.char.MainHand == nil) or (string.len(FSwapper3.db.char.MainHand) == 0)) then
		self:AddLine(format("%s: %s", MAINHANDSLOT, L["|cffff0000[Not Set]|r"]));
	else
		self:AddLine(format("%s: %s", MAINHANDSLOT, FSwapper3.db.char.MainHand));
	end

	if ((FSwapper3.db.char.OffHand == nil) or (string.len(FSwapper3.db.char.OffHand) == 0)) then
		self:AddLine(format("%s: %s", SECONDARYHANDSLOT, L["|cffff0000[Not Set]|r"]));
	else
		self:AddLine(format("%s: %s", SECONDARYHANDSLOT, FSwapper3.db.char.OffHand));
	end

	if ((FSwapper3.db.char.Pole == nil) or (string.len(FSwapper3.db.char.Pole) == 0)) then
		self:AddLine(format("%s: %s", FSwapper3.LFISHINGPOLES, L["|cffff0000[Not Set]|r"]));
	else
		self:AddLine(format("%s: %s", FSwapper3.LFISHINGPOLES, FSwapper3.db.char.Pole));
	end
end

function MainBroker:OnClick(button)
    if (button == "RightButton") then
        GameTooltip:Hide();
        ToggleDropDownMenu(1, nil, FSwapper3Menu, self, 0, 0);
    elseif (dotooltip == 0) then
		FSwapper3:SetEnable();
	elseif (dotooltip == 1) then
		FSwapper3:EquipPole();
	elseif (dotooltip == 2) then
		FSwapper3:EquipWeapons();
	elseif (dotooltip == 3) then
		FSwapper3:EquipPole();
	end
end

function MainBroker:OnEnter()
	if (dotooltip == -1) then
		return;
	end
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
	GameTooltip:ClearLines();
	MainBroker.OnTooltipShow(GameTooltip);
	GameTooltip:Show();
end

function MainBroker:OnLeave()
	GameTooltip:Hide();
end

function SkillBroker:OnTooltipShow()
	self:AddLine("FSwapper3");
	self:AddLine(" ");
	self:AddLine(format("%s: %s", FSwapper3.LFISHINGSKILL, SkillBroker.SkillStr));
	self:AddLine(L["Click to change display format."]);
end

function SkillBroker:OnClick(button)
	if (FSwapper3.db.char.FSTooltip < 2) then
		FSwapper3.db.char.FSTooltip = FSwapper3.db.char.FSTooltip + 1;
	else
		FSwapper3.db.char.FSTooltip = 0;
	end
	FSwapper3:DoDBUpdate();
end

function SkillBroker:OnEnter()
	GameTooltip:SetOwner(self, "ANCHOR_NONE");
	GameTooltip:SetPoint("TOPLEFT", self, "BOTTOMLEFT");
	GameTooltip:ClearLines();
	SkillBroker.OnTooltipShow(GameTooltip);
	GameTooltip:Show();
end

function SkillBroker:OnLeave()
	GameTooltip:Hide();
end

FSwapper3Menu.displayMode = "MENU"
FSwapper3Menu.initialize = function(self, level)
    if (not level) then
        return;
    end
    wipe(menuitem);
    if (level == 1) then
        menuitem.isTitle = 1;
        menuitem.text = "FSwapper3";
        menuitem.notCheckable = 1;
        UIDropDownMenu_AddButton(menuitem, level);
        
        menuitem.disabled     = nil;
        menuitem.isTitle      = nil;
        menuitem.notCheckable = nil;
        
        menuitem.text = ENABLE;
        menuitem.func = FSwapper3.SetEnable;
        menuitem.checked = FSwapper3.db.char.Enable;
        UIDropDownMenu_AddButton(menuitem, level);
        
        menuitem.text = GAMEOPTIONS_MENU;
        menuitem.func = FSwapper3.FS3GUI.Toggle;
        menuitem.checked = nil;
        UIDropDownMenu_AddButton(menuitem, level);
		
        menuitem.text = "GoFish";
        menuitem.func = FSwapper3.EquipPole;
        menuitem.checked = nil;
        UIDropDownMenu_AddButton(menuitem, level);
        
        menuitem.text = "GoFight";
        menuitem.func = FSwapper3.EquipWeapons;
        menuitem.checked = nil;
        UIDropDownMenu_AddButton(menuitem, level);
        
        menuitem.text = "DoSwap";
        menuitem.func = FSwapper3.SwapSet;
        menuitem.checked = nil;
        UIDropDownMenu_AddButton(menuitem, level);
        
        menuitem.text = L["MacroHelp"];
        menuitem.func = FSwapper3.MacroUsage;
        menuitem.checked = nil;
        UIDropDownMenu_AddButton(menuitem, level);
        
        menuitem.text         = CLOSE;
        menuitem.func         = function() CloseDropDownMenus() end;
        menuitem.checked      = nil;
        menuitem.notCheckable = 1;
        UIDropDownMenu_AddButton(menuitem, level);
    end
end