﻿local FSwapper3 = LibStub("AceAddon-3.0"):GetAddon("FSwapper3");
local L = LibStub("AceLocale-3.0"):GetLocale("FSwapper3", true);

local FS3GUI = FSwapper3.FS3GUI;

local TabFrame = FS3GUI.TabFrame;
local WeaponFrame = FS3GUI.SubFrame[1];
local OptionsFrame = FS3GUI.SubFrame[2];
local AutoLootFrame = FS3GUI.SubFrame[3];
local EquipmentFrame = FS3GUI.SubFrame[4];

function OptionsFrame:DoInit()
	OptionsFrame.DidInit = true;
	
	OptionsFrame:SetFrameStrata("DIALOG");
	OptionsFrame:SetWidth(FS3GUI.Width);
	OptionsFrame:SetBackdrop({
			bgFile="Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
			tile = true, tileSize = 32, edgeSize = 32, 
			insets = { left = 8, right = 8, top = 8, bottom = 8 }
		});
	OptionsFrame:SetBackdropColor(0,0,0,1);
	OptionsFrame:EnableMouse();
	OptionsFrame:SetPoint("TOPLEFT", TabFrame, "BOTTOMLEFT", 0, 12);
	
	local frameheight = 13;
	local label;
	OptionsFrame.CheckList = {};
	frameheight = frameheight + 5 +
		OptionsFrame:AddCheck(OptionsFrame.CheckList, ENABLE_SOUNDFX, "Sound", -frameheight);
	OptionsFrame.CheckList[1].Box:SetScript("OnClick", function(self, button)
			if (button == "LeftButton") then
				FSwapper3.db.char.Sound = not FSwapper3.db.char.Sound;
				FSwapper3:PlaySound(FSwapper3.Sounds.Sound);
				OptionsFrame:DoUpdate();
			end
		end);
	
	label = L["Notify when swapping for combat."];
	frameheight = frameheight + 5 +
		OptionsFrame:AddCheck(OptionsFrame.CheckList, label, "bNotify", -frameheight);
		
	label = format(L["Automatically switch between \"%s\" and your last tracking skill."], FSwapper3.LFINDFISH);
	frameheight = frameheight + 5 +
		OptionsFrame:AddCheck(OptionsFrame.CheckList, label, "Track", -frameheight);
	
	frameheight = frameheight + 8;
	OptionsFrame:SetHeight(frameheight);
end

function OptionsFrame:AddCheck(list, label, value, ypos)
	local index = (#list) + 1;
	
	local CheckLine = {};
	CheckLine.Value = value;
	
	CheckLine.Box = CreateFrame("CheckButton", nil, OptionsFrame, "UICheckButtonTemplate");
	CheckLine.Label = OptionsFrame:CreateFontString("$parent_CheckLabel" .. index,"ARTWORK","GameFontNormal");
	
	CheckLine.Box:SetPoint("TOPLEFT", OptionsFrame, "TOPLEFT", 13, ypos);
	CheckLine.Box:SetScript("OnClick", function(self, button)
			if (button == "LeftButton") then
				FSwapper3.db.char[value] = not FSwapper3.db.char[value];
				OptionsFrame:DoUpdate();
			end
		end);
		
	CheckLine.Label:SetWidth(FS3GUI.Width - 26 - CheckLine.Box:GetWidth());
	CheckLine.Label:SetText(label);
	CheckLine.Label:SetJustifyH("LEFT");
	
	list[index] = CheckLine;
	
	local boxcy, labelcy = CheckLine.Box:GetHeight(), CheckLine.Label:GetHeight();
	if (boxcy > labelcy) then
		local shift = (labelcy - boxcy) / 2;
		CheckLine.Label:SetPoint("TOPLEFT", CheckLine.Box, "TOPRIGHT", 0, shift);
		return boxcy;
	else
		CheckLine.Label:SetPoint("TOPLEFT", CheckLine.Box, "TOPRIGHT", 0, 0);
		return labelcy;
	end
end

function OptionsFrame:DoUpdate()
	for i, CheckLine in ipairs(OptionsFrame.CheckList) do
		CheckLine.Box:SetChecked(FSwapper3.db.char[CheckLine.Value]);
	end
end