﻿local FSwapper3 = LibStub("AceAddon-3.0"):NewAddon("FSwapper3", "AceConsole-3.0", "AceEvent-3.0");

local ScanTTGUID = "FS3ScanTT_4A67862A-BC86-4e7b-98B8-A57317EBF3C2";
local ScanTT = CreateFrame("GameTooltip", ScanTTGUID, UIParent, "GameTooltipTemplate");

function ScanTT:OnSetItem()
		local itemname = GetItemInfo("item:" .. self.NextID)
		if (itemname ~= nil) then
			self.ItemList[self.NextID] = itemname;
			self:LocalizeItems();
		end
	end;
	
function ScanTT:LocalizeItems(itemlist)
	if (itemlist ~= nil) then
		self.ItemList = itemlist;
		self:SetScript("OnTooltipSetItem", self.OnSetItem);
	end
	self:SetOwner(WorldFrame, "ANCHOR_NONE");
	self:ClearLines();
	for id, name in pairs(self.ItemList) do
		if (not name) then
			self.NextID = id;
			self:SetHyperlink("item:" .. id);
			return;
		end
	end
	self:SetScript("OnTooltipSetItem", nil);
	self:Hide();
end

FSwapper3.LITEMS = {[19978] = false};

ScanTT:LocalizeItems(FSwapper3.LITEMS);

-- Constants
FSwapper3.nMAINHANDSLOT = (GetInventorySlotInfo("MAINHANDSLOT"));
FSwapper3.nSECONDARYHANDSLOT = (GetInventorySlotInfo("SECONDARYHANDSLOT"));
FSwapper3.nHEADSLOT = (GetInventorySlotInfo("HEADSLOT"));
FSwapper3.nHANDSSLOT = (GetInventorySlotInfo("HANDSSLOT"));
FSwapper3.nFEETSLOT = (GetInventorySlotInfo("FEETSLOT"));
FSwapper3.nTRINKET0SLOT = (GetInventorySlotInfo("TRINKET0SLOT"));
FSwapper3.nTRINKET1SLOT = (GetInventorySlotInfo("TRINKET1SLOT"));

-- Localized Constants
FSwapper3.LFISHINGPOLES = GetSpellInfo(7738);
FSwapper3.LFISHINGSPELL = GetSpellInfo(7620);
FSwapper3.LFISHINGSKILL = format("%s %s", FSwapper3.LFISHINGSPELL, SKILL);
FSwapper3.LFINDFISH = GetSpellInfo(43308);
FSwapper3.LQUEST = (select(12, GetAuctionItemClasses()));

-- Constant Strings
FSwapper3.FS3VERSION = GetAddOnMetadata("FSwapper3", "Version");
FSwapper3.FISHINGSKILL_NULL = "|cffff00000|r";
FSwapper3.FISHINGSKILL_SKILL = "|cffffffff%d|r";
FSwapper3.FISHINGSKILL_BONUS = "|cff00ff00%d|r";
FSwapper3.FISHINGSKILL_SKILL_MAX = "|cffffffff%d/%d|r";
FSwapper3.FISHINGSKILL_BONUS_MAX = "|cff00ff00%d|r|cffffffff/%d|r";
FSwapper3.FISHINGSKILL_SKILL_BONUS_MAX = "|cffffffff%d(|r|cff00ff00+%d|r|cffffffff)/%d|r";
FSwapper3.ISFISHING = format("|cff00ffff[%s]|r", FSwapper3.LFISHINGSPELL);
FSwapper3.ISCOMBAT = format("|cffff0000[%s]|r", COMBAT);
FSwapper3.Sounds = {};

-- File-Locals
FSwapper3.WasFishing = false; -- Temp flag to remember if we were fishing before entering combat
FSwapper3.LASTERR = 0;
FSwapper3.LASTERRT = GetTime();
FSwapper3.WasTracking = nil; -- Temp flag to remember the last tracking skill.